module RechnMgmUserArea
    class NotificationsMailer < ApplicationMailer

        # Subject can be set in your I18n file at config/locales/en.yml
        # with the following lookup:
        #
        #   en.notifications_mailer.documents_waiting.subject
        #
        def documents_waiting(email, document_ids, organisation_name)
            @greeting = I18n.t('invoices_waiting_notification_title', organisation_name: organisation_name)
            @documents = []

            document_ids.each do |document_id|
                document = Nukleus::Document.where(id: document_id).first
                next if document.nil?

                @documents.push document
            end

            mail to: email, subject: @greeting
        end
    end
end
