module RechnMgmUserArea
    class Organisation
        include NoBrainer::Document
        include NoBrainer::Document::Timestamps

        has_many :member_ships,  :class_name => RechnMgmUserArea::MemberShip
        has_many :users,         :through => :member_ships

        field :name,             :type => String

        def notify_waiting_documents
            sachbearbeiter_member_ships = RechnMgmUserArea::MemberShip.where(organisation_id: self.id).map{|m| m}.keep_if { |m| DeviseAuthentication::User.roles_mask_matches_role(m[:roles_mask], 2**ROLES.index("sachbearbeiter")) }

            # check for waiting documents for each sachbearbeiter
            sachbearbeiter_member_ships.each do |membership|
                user = membership.user
                next unless user.is_mail_notification_enabled?

                doc_ids = Nukleus::Document.where(is_exported: false, user_id: membership.user_id, organisation_id: self.id, state: Nukleus::Document.document_states.index(:DOCUMENT_STATE_ASSIGNED) ).pluck(:id)

                if doc_ids.count > 0
                    NotificationsMailer::documents_waiting(user.email, doc_ids.map{|d| d["id"]}, self.name).deliver
                end
            end
        end
    end
end
